/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_SeverityOfComplication;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_SeverityOfComplication;


/**
 * This class represents SeverityOfComplication - CID251
 */
public class SeverityOfComplication_CID251 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new SeverityOfComplication_CID251 Template 
	 */
	public SeverityOfComplication_CID251()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}


	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumSeverityofComplication Object of EnumCM_SeverityOfComplication represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_SeverityOfComplication enumSeverityOfComplication)
	{
		switch(enumSeverityOfComplication)
		{
		case MAJOR: this.strCodeValue =EnumCV_SeverityOfComplication.MAJOR_R_404F9.getValue(); break;
		case MINOR: this.strCodeValue =EnumCV_SeverityOfComplication.MINOR_R_404FC.getValue(); break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumSeverityOfComplication Object of EnumCM_SeverityOfComplication represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_SeverityOfComplication enumSeverityOfComplication)
	{
		switch(enumSeverityOfComplication)
		{
		case MAJOR : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.MAJOR.getSNOMEDCTID(); break;
		case MINOR : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.MINOR.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for SeverityOfComplication
	 * @param enumSeverityOfComplication Object of EnumCM_SeverityOfComplication.
	 */
	public void setSeverityOfComplication(EnumCM_SeverityOfComplication enumSeverityOfComplication)
	{
		this.strCodeMeaning = enumSeverityOfComplication.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		setCodeValue(enumSeverityOfComplication);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumSeverityOfComplication);
	}
}
